//************************************************************************
// T6963.H
#include <avr/io.h>
#include <avr/pgmspace.h>

/* Meine Pinbelegung am ATmega32:
 D0-D7 an Port C 0-7
 Steuerleitung an Port D
*/

//PORTC ist der Datenport
#define DATA_DIR_IN()  DDRC =0x00;
#define DATA_DIR_OUT() DDRC =0xFF;
#define LCD_READ   PINC	  							// read PINC, ! NOT ! PORTC
#define LCD_WRITE  PORTC							//PORTB=(a); // write to data port

#define LCD_WR		0								// LCD_WRITE
#define LCD_RD		1								// LCD_READ
#define LCD_CE		2								// LCD_CS
#define LCD_CD		3								// LCD_COMMAND/DATA
#define LCD_RST		4								// LCD_RESET
#define LCD_FS 		5								// LCD Font Select
#define LCD_RV		6								// Reverse Data
#define LCD_CTRL	PORTD							// Steuerport LCD

#define LCD_WR_H()   	LCD_CTRL |=  _BV(LCD_WR)	// = 1
#define LCD_WR_L()    	LCD_CTRL &= ~_BV(LCD_WR)	// = 0
#define LCD_RD_H()   	LCD_CTRL |=  _BV(LCD_RD)
#define LCD_RD_L()    	LCD_CTRL &= ~_BV(LCD_RD)
#define LCD_CE_H()   	LCD_CTRL |=  _BV(LCD_CE)
#define LCD_CE_L()    	LCD_CTRL &= ~_BV(LCD_CE)
#define LCD_CD_H()   	LCD_CTRL |=  _BV(LCD_CD)
#define LCD_CD_L()    	LCD_CTRL &= ~_BV(LCD_CD)
#define LCD_RST_H()   	LCD_CTRL |=  _BV(LCD_RST)
#define LCD_RST_L()    	LCD_CTRL &= ~_BV(LCD_RST)
#define LCD_FS_H()   	LCD_CTRL |=  _BV(LCD_FS)
#define LCD_FS_L()    	LCD_CTRL &= ~_BV(LCD_FS)
#define LCD_RV_H()   	LCD_CTRL |=  _BV(LCD_RV)
#define LCD_RV_L()    	LCD_CTRL &= ~_BV(LCD_RV)

#define lcd_puts_P(__s)         lcd_puts_p(PSTR(__s))

#define XMAX	239		//Display Breite
#define XMIN	0		
#define YMAX	127		//Display Hhe
#define	YMIN	0
#define T_BASE	0x000	//Start-Adresse Text
#define G_BASE	0x300	//Start-Adresse Grafik
#define BYTES_PER_ROW	40		//40=6*8  30=8*8

void lcd_init(void);
void lcd_status(void);
void lcd_status_am(void);
void lcd_send_cmd(char cmd);
void lcd_send_data(char data);
void lcd_send_data_am(char data);
void lcd_printp(const char *progmem_s, char adress_h, char adress_l);
void lcd_print(char *txt, char adress_h, char adress_l);
void lcd_send_str(unsigned char);
void lcd_clear_ram(void);
char * IntToAsciiHex(char * dest_string,int min_digits,unsigned int value);
char * IntToAsciiDec(char * dest_string,int min_digits,unsigned int value);
void lcd_printg(const char *progmem_s, char adress_h, char adress_l);
void lcd_send_strg(unsigned char lcd_dat);
void lcd_setpixel(int x, int y);


